package com.flashbelt {
	import caurina.transitions.Tweener;

	import com.bit101.components.HUISlider;
	import com.bit101.components.PushButton;
	import com.bit101.components.Window;
	import com.uncontrol.BoilerPlate;

	import org.papervision3d.Papervision3D;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.core.geom.renderables.Line3D;
	import org.papervision3d.core.math.Number3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.MovieMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;

	import flash.display.Sprite;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;

	// bit101 import
	
	// pv3 import

	// tweens

	// flash import
		
	// uncontrol import

	/**
	 * @author mannytan
	 */
	[SWF(width="620", height="620", backgroundColor="#432804", frameRate="45")]
	public class Flashbelt extends BoilerPlate {
		private var scene : Scene3D;
		private var renderer : BasicRenderEngine;
		private var viewport : Viewport3D;
		private var camera : Camera3D;
		private var base : DisplayObject3D;
		private var cameraTarget : DisplayObject3D;
		private var cameraData : Object;
		private var isOrbiting : Boolean = false;
		private var previousMouseX : Number;
		private var previousMouseY : Number;
		private var isKeyPressed : Boolean = false;
		private var TWO_PI : Number = Math.PI * 2;
		private var counter : int = 0;
		private var mSphereVertices : Array;
		private var mPlane : Plane;
		private var totalSegmentsA : int = 7;
		private var totalSegmentsB : int = 15;
		private var number3DArray : Array;
		private var transformed3DArray : Array;
		private var planeArray : Array;
		private var planeTotal : int = 6;
		private var sliderWindow : Window;
		private var pivotSlider : HUISlider;
		private var pivotOffsetSlider : HUISlider;
		private var swivelSlider : HUISlider;
		private var scaleSlider : HUISlider;
		private var wingSpreadSlider : HUISlider;
		private var wingLengthSlider : HUISlider;
		private var mainRotationXSlider : HUISlider;
		private var mainRotationYSlider : HUISlider;
		private var sliderHUISliderArray : Array;
		private var square : Sprite;

		public function Flashbelt() {
			setClassScope('Flashbelt');

			cameraData = new Object();
			cameraData.pitch = 47;
			cameraData.yaw = 288;
			mSphereVertices = new Array();
			this.addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}

		public function init(event : Event = null) : void {
			tracer('init');
			this.removeEventListener(Event.ADDED_TO_STAGE, init);

			// stage.displayState 	= StageDisplayState.FULL_SCREEN;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.quality = StageQuality.LOW;

			square = new Sprite();
			square.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDownHandler, false, 0, true);
			square.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMoveHandler, false, 0, true);
			square.addEventListener(MouseEvent.MOUSE_UP, onMouseUpHandler, false, 0, true);
			square.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheelHandler, false, 0, true);
			stage.addEventListener(Event.RESIZE, onStageResize);

			createWorld();
			// createGridMarks();
			createShapes();
			createControls();

			stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDownHandler, false, 0, true);
			stage.addEventListener(KeyboardEvent.KEY_UP, onKeyUpHandler, false, 0, true);

			this.addEventListener(Event.ENTER_FRAME, update);

			isKeyPressed = true;
			onMouseDownHandler();
			onMouseMoveHandler();
			onMouseUpHandler();
			// isKeyPressed = false;
		}
	
		private function onStageResize(event : Event = null) : void {

		}
		/**
		 * create world sets the defaults for all papervision info
		 * base is the displayObject3D that everything is applied to similiar to this.context
		 * baseOffset is used for and world transformations 
		 */
		public function createWorld() : void {
			viewport = new Viewport3D(stage.stageWidth, stage.stageHeight, false, true, true);
			viewport.containerSprite.name = 'paperBaseView';
			// name required for hit with construction
			viewport.interactive = true;

			Papervision3D.useDEGREES = true;

			square.graphics.beginFill(0x432804);
			square.graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
			square.graphics.endFill();

			this.addChild(square);

			square.addChild(viewport);

			renderer = new BasicRenderEngine();
			scene = new Scene3D();

			base = new DisplayObject3D();
			base.extra = new Object();
			scene.addChild(base);

			cameraTarget = new DisplayObject3D();
			base.addChild(cameraTarget);

			camera = new Camera3D();
			camera.extra = new Object();

			camera.target = cameraTarget;
		}

		/**
		 * create XYZ marks for easy viewing
		 */
		public function createGridMarks() : void {
			var grid3D = new DisplayObject3D();
			var clutMat = new WireframeMaterial();
			var cursor : Plane;

			clutMat = new WireframeMaterial(0xFF0000, 1);
			clutMat.doubleSided = true;
			cursor = new Plane(clutMat, 1, 500, 1, 1);
			grid3D.addChild(cursor);

			clutMat = new WireframeMaterial(0x00FF00, 1);
			clutMat.doubleSided = true;
			cursor = new Plane(clutMat, 1, 500, 1, 1);
			cursor.rotationX = 90;
			grid3D.addChild(cursor);

			clutMat = new WireframeMaterial(0x0000FF, 1);
			clutMat.doubleSided = true;

			cursor = new Plane(clutMat, 1, 500, 1, 1);
			cursor.rotationX = 90;
			cursor.rotationY = 90;

			grid3D.addChild(cursor);
			base.addChild(grid3D);
		}

		/**
		 * create slider controls
		 */
		private function createControls() : void {
			sliderHUISliderArray = new Array();
			var yOffset : Number = 30;
			var leftMargin : Number = 8;
			var sliderWidth : Number = 200;

			// hack for now, will remove in the future
			sliderWindow = new Window(this, 10, 10, 'ADVANCED\t\t\t\t\t\t\t Use spacebar to randomize values');
			sliderWindow.width = 380;
			sliderWindow.height = 140;
			sliderWindow.hasMinimizeButton = true;
			sliderWindow.shadow = false;
			sliderWindow.minimized = true;
			sliderWindow.addEventListener(Event.RESIZE, onComponentWindowChangeHandler, false, 0, true);
			sliderWindow.color = 0xFFFFFF;
			// sliderWindow.visible = false;

			pivotSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "pivotSlider");
			pivotSlider.minimum = 0;
			pivotSlider.maximum = 360;
			pivotSlider.value = 20;
			pivotSlider.tick = .001;
			sliderHUISliderArray.push(pivotSlider);
			yOffset += 20;

			pivotOffsetSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "pivotOffsetSlider");
			pivotOffsetSlider.minimum = 0;
			pivotOffsetSlider.maximum = 360;
			pivotOffsetSlider.value = 180;
			pivotOffsetSlider.tick = .001;
			sliderHUISliderArray.push(pivotOffsetSlider);
			yOffset += 20;

			swivelSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "swivelSlider");
			swivelSlider.minimum = -360;
			swivelSlider.maximum = 360;
			swivelSlider.value = -25;
			swivelSlider.tick = .001;
			sliderHUISliderArray.push(swivelSlider);
			yOffset += 20;

			scaleSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "scaleSlider");
			scaleSlider.minimum = -3;
			scaleSlider.maximum = 3;
			scaleSlider.value = 0;
			scaleSlider.tick = .001;
			sliderHUISliderArray.push(scaleSlider);
			yOffset += 20;

			leftMargin = 190;
			yOffset = 30;

			wingSpreadSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "wingSpreadSlider");
			wingSpreadSlider.minimum = -200;
			wingSpreadSlider.maximum = 200;
			wingSpreadSlider.value = 60;
			wingSpreadSlider.tick = .001;
			sliderHUISliderArray.push(wingSpreadSlider);
			yOffset += 20;

			wingLengthSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "wingLengthSlider");
			wingLengthSlider.minimum = -100;
			wingLengthSlider.maximum = 100;
			wingLengthSlider.value = 30;
			wingLengthSlider.tick = .001;
			sliderHUISliderArray.push(wingLengthSlider);
			yOffset += 20;

			mainRotationXSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "mainRotationXSlider");
			mainRotationXSlider.minimum = -500;
			mainRotationXSlider.maximum = 500;
			mainRotationXSlider.value = 400;
			mainRotationXSlider.tick = .001;
			sliderHUISliderArray.push(mainRotationXSlider);
			yOffset += 20;

			mainRotationYSlider = new HUISlider(sliderWindow, leftMargin, yOffset, "mainRotationYSlider");
			mainRotationYSlider.minimum = -500;
			mainRotationYSlider.maximum = 500;
			mainRotationYSlider.value = 0;
			mainRotationYSlider.tick = .001;
			sliderHUISliderArray.push(mainRotationYSlider);
			yOffset += 20;

			for (var i : int = 0; i < sliderHUISliderArray.length; i++ ) {
				var slider : HUISlider = sliderHUISliderArray[i];
				slider.label = '';
				slider.width = sliderWidth;
				slider.visible = false;
			}
		}

		/**
		 * Trigger when component window is minimized/maximized
		 * @param	e
		 */
		private function onComponentWindowChangeHandler(e : Event = null) : void {
			for (var i : int = 0; i < sliderHUISliderArray.length; i++ ) {
				sliderHUISliderArray[i].visible = !e.target.minimized;
			}
		}

		private function setRandomControlPositions() : void {
			var time : Number = 5.0;

			for (var i : int = 0; i < sliderHUISliderArray.length; i++ ) {
				var slider : HUISlider = sliderHUISliderArray[i];
				Tweener.addTween(slider, {value:(slider.maximum - slider.minimum) * Math.random() + slider.minimum, time:time, transition:'easeInOutQuad'});
			}
		}

		/**
		 * create shapes based on primitives
		 */
		public function createShapes() : void {
			var i : uint;
			var j : uint;
			var seed : int;
			var wireMaterialA : WireframeMaterial = new WireframeMaterial(0xd8d3a4, .5);
			wireMaterialA.doubleSided = true;
			wireMaterialA.interactive = false;
			var wireMaterialB : WireframeMaterial = new WireframeMaterial(0xd16f1b, .5);
			wireMaterialB.doubleSided = true;
			wireMaterialB.interactive = false;
			var wireMaterialC : WireframeMaterial = new WireframeMaterial(0x70cee4, .5);
			wireMaterialC.doubleSided = true;
			wireMaterialC.interactive = false;

			var colorMaterialA : ColorMaterial = new ColorMaterial(0xd8d3a4, .5);
			colorMaterialA.doubleSided = true;
			colorMaterialA.interactive = false;
			var colorMaterialB : ColorMaterial = new ColorMaterial(0xd16f1b, .5);
			colorMaterialB.doubleSided = true;
			colorMaterialB.interactive = false;
			var colorMaterialC : ColorMaterial = new ColorMaterial(0x70cee4, .5);
			colorMaterialC.doubleSided = true;
			colorMaterialC.interactive = false;

			planeArray = new Array();

			var do3D : DisplayObject3D;
			var doInsideD : DisplayObject3D;

			// var materialArray:Array = [colorMaterialC, colorMaterialA, colorMaterialB, colorMaterialC,colorMaterialA, colorMaterialB];
			var materialArray : Array = [wireMaterialC, wireMaterialA, wireMaterialB, wireMaterialC, wireMaterialA, wireMaterialB];
			for (j = 0; j < 3; j++) {
				do3D = new DisplayObject3D();
				do3D.rotationY = j * 120;
				base.addChild(do3D);

				//
				doInsideD = new DisplayObject3D();
				doInsideD.z = -100;
				do3D.addChild(doInsideD);
				mPlane = new Plane(materialArray.pop(), 1000, 1000, totalSegmentsA - 1, totalSegmentsB - 1);
				planeArray.push(mPlane);
				doInsideD.addChild(mPlane);

				//
				doInsideD = new DisplayObject3D();
				doInsideD.z = 100;
				doInsideD.scaleZ = -1.0;
				do3D.addChild(doInsideD);
				mPlane = new Plane(materialArray.pop(), 1000, 1000, totalSegmentsA - 1, totalSegmentsB - 1);
				planeArray.push(mPlane);
				doInsideD.addChild(mPlane);
			}

			number3DArray = new Array();
			seed = 0;
			for (j = 0; j < totalSegmentsA; j++) {
				for (i = 0; i < totalSegmentsB; i++) {
					number3DArray[seed] = new Number3D(0, 0, 0);
					seed++;
				}
			}
		}


		/**
		 * returns point after rotation
		 * @param	oldPoint
		 * @param	anchorPoint
		 * @param	degrees
		 * @return
		 */
		public function getRotatedPoint(oldPoint : Point, anchorPoint : Point, degrees : Number = 0) : Point {
			var relativePoint : Point = oldPoint.subtract(anchorPoint);
			var angleExisting : Number = Math.atan2(relativePoint.y, relativePoint.x);
			var angleToBeRotated = TWO_PI * (	degrees / 360);
			var distance = Point.distance(anchorPoint, oldPoint);
			return Point.polar(distance, angleToBeRotated + angleExisting).add(anchorPoint);
		}

		/**
		 * loop via Event.ENTER_FRAME
		 * @param	e
		 */
		public function update(e : Event) : void {
			var i : uint;
			var j : uint;
			var k : uint;
			var seed : int;
			var geometrySeed : int;

			var circleRadius : Number = 100;

			var oldNum3D : Number3D;

			var transformANum3D : Number3D;
			var anchorANum3D : Number3D = new Number3D(0, 0, 0);

			var transformBNum3D : Number3D;
			var anchorBNum3D : Number3D = new Number3D(mainRotationXSlider.value, mainRotationYSlider.value, 0);

			var transformCNum3D : Number3D;
			var anchorCNum3D : Number3D = new Number3D(0, 0, 0);

			transformed3DArray = new Array();

			var mainAngle : Number = 0;

			// parse
			seed = 0;

			for (j = 0; j < totalSegmentsA; j++) {
				for (i = 0; i < totalSegmentsB; i++) {
					oldNum3D = number3DArray[seed];

					// ------------------------------------------------
					// offsets away from center
					oldNum3D.x = i * wingLengthSlider.value + 25;
					oldNum3D.y = j * wingSpreadSlider.value - (totalSegmentsA - 1) * wingSpreadSlider.value / 2;
					oldNum3D.z = 0;

					if (j <= (totalSegmentsA / 2)) {
						mainAngle = (.25 - .5) * pivotOffsetSlider.value + 90 + pivotSlider.value;
					} else {
						mainAngle = (.25 - .5) * -pivotOffsetSlider.value + 90 + pivotSlider.value;
					}
					transformANum3D = getRotationAroundAnchorX(oldNum3D, anchorANum3D, mainAngle);
					transformed3DArray[seed] = transformANum3D;

					// ------------------------------------------------
					transformBNum3D = getRotationAroundAnchorZ(transformANum3D, anchorBNum3D, i / (totalSegmentsB - 1) * swivelSlider.value);
					transformed3DArray[seed] = transformBNum3D;

					// ------------------------------------------------
					transformCNum3D = getScalarAroundAnchor(transformBNum3D, anchorCNum3D, 1 + i / (totalSegmentsB - 1) * scaleSlider.value);
					transformed3DArray[seed] = transformCNum3D;

					seed++;
				}
			}

			// draw
			seed = 0;
			geometrySeed = 0;

			for (j = 0; j < totalSegmentsA; j++) {
				for (i = 0; i < totalSegmentsB; i++) {
					geometrySeed = i + j * totalSegmentsB;

					for (k = 0; k < planeTotal; k++) {
						mPlane = planeArray[k];
						mPlane.geometry.vertices[geometrySeed].x = transformed3DArray[seed].x;
						mPlane.geometry.vertices[geometrySeed].y = transformed3DArray[seed].y;
						mPlane.geometry.vertices[geometrySeed].z = transformed3DArray[seed].z;
					}
					seed++;
				}
			}

			counter++;
			// draw
			base.rotationY += .125;
			renderer.renderScene(scene, camera, viewport);
			// standard loop requred to render papervision
		}

		public function getRotationAroundAnchorZ(oldPoint3D : Number3D, anchorPoint3D : Number3D, degrees : Number = 0) : Number3D {
			var newPoint3D : Number3D = Number3D.sub(oldPoint3D.clone(), anchorPoint3D);
			newPoint3D.rotateZ(degrees);
			return Number3D(Number3D.add(newPoint3D, anchorPoint3D));
		}

		public function getRotationAroundAnchorX(oldPoint3D : Number3D, anchorPoint3D : Number3D, degrees : Number = 0) : Number3D {
			var newPoint3D : Number3D = Number3D.sub(oldPoint3D.clone(), anchorPoint3D);
			newPoint3D.rotateX(degrees);
			return Number3D(Number3D.add(newPoint3D, anchorPoint3D));
		}

		public function getRotationAroundAnchorY(oldPoint3D : Number3D, anchorPoint3D : Number3D, degrees : Number = 0) : Number3D {
			var newPoint3D : Number3D = Number3D.sub(oldPoint3D.clone(), anchorPoint3D);
			newPoint3D.rotateY(degrees);
			return Number3D(Number3D.add(newPoint3D, anchorPoint3D));
		}

		public function getScalarAroundAnchor(oldPoint3D : Number3D, anchorPoint3D : Number3D, ratio : Number = 0) : Number3D {
			var newPoint3D : Number3D = Number3D.sub(oldPoint3D.clone(), anchorPoint3D);
			newPoint3D.multiplyEq(ratio);
			return Number3D(Number3D.add(newPoint3D, anchorPoint3D));
		}

		public function getTranslationAroundAnchor(oldPoint3D : Number3D, anchorPoint3D : Number3D) : Number3D {
			return Number3D(Number3D.add(oldPoint3D.clone(), anchorPoint3D));
		}

		private function onKeyUpHandler(e : KeyboardEvent = null) : void {
			if (e.keyCode == 32) {
				setRandomControlPositions();
			}
		}

		private function onKeyDownHandler(event : KeyboardEvent = null) : void {
			// trace('onKeyDownHandler',e.keyCode);
		}

		private function onMouseWheelHandler(event : MouseEvent = null) : void {
			camera.moveForward(30 * event.delta);
		}

		private function onMouseDownHandler(event : MouseEvent = null) : void {
			if (sliderWindow.hitTestPoint(mouseX, mouseY, true) && !sliderWindow.minimized) return;

			if (!isKeyPressed) return;
			isOrbiting = true;
			previousMouseX = mouseX;
			previousMouseY = mouseY;
			onMouseMoveHandler();
		}

		private function onMouseUpHandler(event : MouseEvent = null) : void {
			isOrbiting = false;
		}

		private function onMouseMoveHandler(event : MouseEvent = null) : void {
			if (!isKeyPressed) return;
			var differenceX : Number = mouseX - previousMouseX;
			var differenceY : Number = mouseY - previousMouseY;

			if (isOrbiting) {
				cameraData.pitch += differenceY;
				cameraData.yaw += differenceX;

				cameraData.pitch %= 360;
				cameraData.yaw %= 360;

				cameraData.pitch = cameraData.pitch < 90 ? cameraData.pitch : 89.9999;
				cameraData.pitch = cameraData.pitch > 0 ? cameraData.pitch : 0.0001;

				previousMouseX = mouseX;
				previousMouseY = mouseY;

				camera.orbit(cameraData.pitch, cameraData.yaw);
			}
		}

		private function randomNumber(radius : Number = 1000) : Number {
			return (int(Math.random() * radius / 2));
		}
	}
}
