package com.uncontrol {
	import com.uncontrol.BoilerPlate;
	import flash.geom.Point;
	
	public class SimplePlotter extends BoilerPlate {

		private var leadPoint:Point;
		private var followPoint:Point;

		private var a:Point;
		private var b:Point;
		private var c:Point;
		private var d:Point;
		private var e:Point;
		private var f:Point;
		
		private var elasticity:Number = .1;
		private var smoothness:Number = .5;
		
		public function SimplePlotter():void {
			setClassScope('SimplePlotter');
		}
		
		public function init():void {
			tracer('init');
			reset();
		}
		
		public function reset(arg:Point = null):void {
			// tracer('reset');

			if(arg == null){
				arg = new Point();
			}
			followPoint = arg.clone();
			leadPoint = arg.clone();
			
			a = arg.clone();
			b = arg.clone();
			c = arg.clone();
			d = arg.clone();
			e = arg.clone();
			f = arg.clone();
		}
		
		public function parse():void {

			a.x = leadPoint.x;
			a.y = leadPoint.y;

			d.x = (a.x - b.x)*elasticity + b.x;
			e.x = b.x - (b.x-c.x) - (b.x-d.x);
			f.x = e.x - (b.x-e.x)*smoothness;
			b.x = e.x;
			c.x = f.x;
			          
			d.y = (a.y - b.y)*elasticity + b.y;
			e.y = b.y - (b.y-c.y) - (b.y-d.y);
			f.y = e.y - (b.y-e.y)*smoothness;
			b.y = e.y;
			c.y = f.y;
			          
			a.x = b.x;
			a.y = b.y;
			
			setFollowPoint(a);
		}
		
		// -------------------------------------------------------------------------------------------
		// getter setter methods
		// -------------------------------------------------------------------------------------------
		public function getFollowPoint():Point{
			// return followPoint;
			return followPoint;
		}
		public function setFollowPoint(arg:Point=null):void{
			followPoint = arg;
		}
		
		public function getLeadPoint():Point{
			return leadPoint;
		}
		public function setLeadPoint(arg:Point=null):void{
			leadPoint = arg;
		}
		
		public function getElasticity():Number{
			return elasticity;
		}
		public function setElasticity(arg:Number=.1):void{
			elasticity = arg;
		}
		
		public function getSmoothness():Number{
			return smoothness;
		}
		public function setSmoothness(arg:Number=.5):void{
			smoothness = arg;
		}
	}
}


